#include <avr/io.h>
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */
#include "usbdrv.h"

#define VENDOR_RQ_SET_NUMBER	0
#define VENDOR_RQ_SET_ADDING	1
#define VENDOR_RQ_RESET		2

usbMsgLen_t usbFunctionSetup(uchar data[8])
{
	usbRequest_t *rq = (void *) data ;

	if (rq->bRequest == VENDOR_RQ_SET_NUMBER)
	{
		DDRC = 0b00111111;
		PORTC = rq->wValue.bytes[0];
		return 0;
	}
	else if (rq->bRequest == VENDOR_RQ_SET_ADDING)
	{
		DDRC = 0b00111111;
		PORTC = rq->wValue.bytes[0];
		return 0;
	}
	else if (rq->bRequest == VENDOR_RQ_RESET)
	{
		DDRC = 0b00000000;
		return 0;
	}
	return 0;
}

int main()
{
    usbInit();
    usbDeviceDisconnect();
    _delay_ms(300);
    usbDeviceConnect();
    sei();
    while (1)
    {   
        usbPoll();
    }
    return 0;
}
