import usb
import sys, termios, atexit
from select import select

def getch():
    return sys.stdin.read(1)

def kbhit():
    dr,dw,de = select([sys.stdin], [], [], 0)
    return dr <> []

def find_board():
  board = None
  for bus in usb.busses():
    for dev in bus.devices:
      if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
        return dev
  return None

def digit1_green(digit):
  if (digit == 0):
    return 0b00000000
  if (digit == 1):
    return 0b00000001
  if (digit == 2):
    return 0b00000010
  if (digit == 3):
    return 0b00000011
  if (digit == 4):
    return 0b00010000
  if (digit == 5):
    return 0b00010001
  if (digit == 6):
    return 0b00010010
  if (digit == 7):
    return 0b00010011
  if (digit == 8):
    return 0b00000100
  if (digit == 9):
    return 0b00000101

def digit2_green(digit):
  if (digit == 0):
    return 0b00001000
  if (digit == 1):
    return 0b00001001
  if (digit == 2):
    return 0b00001010
  if (digit == 3):
    return 0b00001011
  if (digit == 4):
    return 0b00011000
  if (digit == 5):
    return 0b00011001
  if (digit == 6):
    return 0b00011010
  if (digit == 7):
    return 0b00011011
  if (digit == 8):
    return 0b00001100
  if (digit == 9):
    return 0b00001101

def digit1_red(digit):
  if (digit == 0):
    return 0b00100000
  if (digit == 1):
    return 0b00100001
  if (digit == 2):
    return 0b00100010
  if (digit == 3):
    return 0b00100011
  if (digit == 4):
    return 0b00110000
  if (digit == 5):
    return 0b00110001
  if (digit == 6):
    return 0b00110010
  if (digit == 7):
    return 0b00110011
  if (digit == 8):
    return 0b00100100
  if (digit == 9):
    return 0b00100101

def digit2_red(digit):
  if (digit == 0):
    return 0b00101000
  if (digit == 1):
    return 0b00101001
  if (digit == 2):
    return 0b00101010
  if (digit == 3):
    return 0b00101011
  if (digit == 4):
    return 0b00111000
  if (digit == 5):
    return 0b00111001
  if (digit == 6):
    return 0b00111010
  if (digit == 7):
    return 0b00111011
  if (digit == 8):
    return 0b00101100
  if (digit == 9):
    return 0b00101101

def change_number():
  player_in = input("IN (01-99): ")
  player_out = input("OUT (01-99): ")
  print "Enter to reset."
  val1 = digit1_green(player_in/10)
  val2 = digit2_green(player_in%10)
  val3 = digit1_red(player_out/10)
  val4 = digit2_red(player_out%10)
  while True:
    req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
    handle.controlMsg(req, 0 , None , value = val1)
    handle.controlMsg(req, 0 , None , value = val2)
    handle.controlMsg(req, 0 , None , value = val3)
    handle.controlMsg(req, 0 , None , value = val4)
    if kbhit():
      ch = getch()
      break
  handle.controlMsg(req, 2 , None , value = 0x0000)

def adding():
  add_time = input("ADDING TIME : ")
  req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
  handle.controlMsg(req, 1 , None , value = digit1_red(add_time%10))
  print "Enter to reset"
  while True:
    if kbhit():
      ch = getch()
      break
  handle.controlMsg(req, 2 , None , value = 0x0000)


# save the terminal settings
fd = sys.stdin.fileno()
new_term = termios.tcgetattr(fd)
old_term = termios.tcgetattr(fd)
# new terminal setting unbuffered
new_term[3] = (new_term[3] & ~termios.ICANON & ~termios.ECHO)

while True:
  board = find_board()
  handle = board.open()
  print "==========================="
  print "=           Menu          ="
  print "==========================="
  print "1.Change Player"
  print "2.Adding Time"
  print "3.Exit"
  
  inp = input("Enter choice : ")
  if (inp == 1):
    change_number()
  elif (inp == 2):
    adding()
  elif (inp == 3):
    quit()
